declare filename "tapeSim.dsp"; declare name "tapeSim"; //import("stdfaust.lib");
//import("guitarix.lib");
//import("redeye.lib");
//import("maths.lib");

SR = 44100;
PI = 3.1415926535897932385;

if(cond,then,else) = select2(cond,else,then);

// ((( lfo + 1 ) *5)+5) from vibrato
//wow = sine( freq )* depth with{
wow =  sdelay(N, interp, delaytime) with{
	freq =  hslider("wowfreq",0.0,0.0,4.0,0.00001);
	depth =  hslider("wowdepth",0.0,0.0,0.03,0.00001);
	sine(freq) = (oscs(freq) + 1) / 2 : max(0); // max(0) because of numerical inaccuracy what is range of this
	modulation = (( sine( freq ) + 1 ) * 5)* depth ; // This should give number between 0-10 ms ??
	delaytime = modulation * SR/1000;
	N 	= int(2^12);  
	interp = 100.0 *SR/1000.0;
};

flutter = sdelay(N, interp, modulation*SR/1000.0) with{
	freq =  hslider("flutterfreq",4,4,60,0.00001);
	depth = hslider("flutterdepth",0.,0.,3.,0.0001);
	sine(freq) = (oscs(freq) + 1) / 2 : max(0); // max(0) because of numerical inaccuracy
	modulation = ((( sine( freq ) + 1 ) *5))* depth ;
	N 	= int(2^12);  
	interp = 100.0 *SR/1000.0;
};

impulse = 1-1';
bypass(switch, block) = _ <: select2(switch, _, block);

oscs(f) = (*(-1) : sint(wn) : sintp(wn,impulse)) ~ _
with {
  wn = 2*PI*f/SR; // approximate
  // wn = 2*sin(PI*f/SR); // exact
  sint(x) = *(x) : + ~ _ ; // frequency-scaled integrator
  sintp(x,y) = *(x) : +(y): + ~ _ ; // same + state input
};

// Each tape recorde rhas its own frequency response 
// Revox A77 
// Hump in bass around 50Hz around 2-3dB
// Gentle slope from 100Hz down to 10K about -3dB
// fairly steep rolloff after that
// Can it be done with fi.iir or fi.fir?
 
// Try to boost highs 1st then cut after to get frequency dependent compressor
// These filters very subtly boost and cut highs 
// So should be that the highs are more compressed - which seems to sound better
// may be look into better filter curve
tapesaturate = filter1:sigmoid:filter2:lowpass( 3, 15000):highpass(1,25) with {
//tapesaturate = sigmoid:fi.lowpass( 3, 15000):fi.highpass(1,25) with {
  sigmoid(x) = 2.0/( 1.0 + exp(-5.0*x)) - 1.0;

	filter1 = iir((1.0, 0.0, 0.0), (0.3 , 0.0 ,0.0)); // Boost higher frequencies
	filter2 = iir((1.0, 0.0, 0.0), (-0.3 , 0.0 ,0.0));	// Cut higher frequencies

};
// We can incorporate a speed switch ( 7.5 ips / 15 ips )
// This would then select an alternative response curve
// 7.5 ips Revox has no bass hump and cuts treble off even more sharply
// In theory the frequency of no.noise would also double
speed = checkbox("speed"); 

taperesponse = _<:select2(tapetype, taperesponse1, taperesponse2 ):tapehiss with{

	// This is loosely based on Revox B77
	tapetype = hslider("tapetype", 0, 0, 1,1);
	taperesponse1 = select2(speed ,taperesponse1b,taperesponse1a);
	// Taperesponses
	// Revoc B77
	// 7.5ips
	taperesponse1a = highpass(1,25):lowpass( 1, 10000 ):lowpass( 2, 12500 );	
	// 15 ips
	taperesponse1b = highpass(1,25):peak_eq_cq(3, 50, 0.4 ):lowpass( 1, 12500 ):lowpass( 2, 15000 ) ;

	// Loosely based on Tascam A3340X
	taperesponse2 = select2( speed ,taperesponse2b,taperesponse2a);
	
	// TASCAM Q = 0.4 peak 9dB -- Although the sub lowpass works creates a lot of unwanted high end 
	//7.5ips
	taperesponse2a = highpass(1,25):peak_eq_cq(6,75,0.4):sub~lowpass( 1, 4500 ):lowpass( 4, 10000 );
	// 15ips
	taperesponse2b = highpass(1,35):peak_eq_cq(6,75,0.4):sub~lowpass( 1, 4500 ):lowpass( 4, 15000 );

	// Sort this out so level is -XXdB no.noise floor
	tapehiss = _<:_,(noise * level:hissfilter):>_ ;
	level = hslider("tapehiss", 0.0, 0.0, 1.0, 0.00001):*(0.0316):smooth( 0.9999) ;
	scale = ( ( 1.0-speed) + 1.0 )/2.0 ;
	// Might be able to simplify this once I get to grips with IIR and fi.fir....!
	// Current value is pretty good approximation of actual tape hiss 
	hissfilter = _<:(highpass(1,3000):*(0.2)),lowpass( 1, 250 ):>lowpass( 2, 15000*scale );

} ;

noise = random / RANDMAX
with{
	mask = 4294967295; // 2^32-1
	random = +(12345) ~ *(1103515245) & mask; // "linear congruential"
	RANDMAX	= 2147483647.0; // = 2^31-1 = MAX_SIGNED_INT in 32 bits
};

machine =  tapesaturate:taperesponse:wow:flutter;

// This is standard IEC eq maybe wrong way round as I want highs saturated more than lows
iec_in = lowpass( 1, 4500 );
iec_out = sub~lowpass( 1, 4500 );

// 12AU7
input12au7 = pre : iir((b0/a0,b1/a0),(a1/a0)) with {
    LogPot(a, x) = if(a, (exp(a * x) - 1) / (exp(a) - 1), x);
    Inverted(b, x) = if(b, 1 - x, x);
    s = 0.993;
    fs = float(SR);
    pre = _;

    Drive = hslider("drive", 0.5, 0, 1, 0.00001) : Inverted(0) : LogPot(1) : smooth(s);
        
    b0 = -0.000275923691873229*Drive*fs;
    b1 = 0.000275923691873229*Drive*fs;
    a0 = 2.08237299868718e-5*fs + 0.000460960630154374;
    a1 = -2.08237299868718e-5*fs + 0.000460960630154374;
};

output12au7 = pre : iir((b0/a0,b1/a0),(a1/a0)) with {
    LogPot(a, x) = if(a, (exp(a * x) - 1) / (exp(a) - 1), x);
    Inverted(b, x) = if(b, 1 - x, x);
    s = 0.993;
    fs = float(SR);
    pre = _;

    Gain = hslider("gain", 0.5, 0, 1, 0.00001) : Inverted(1) : LogPot(1) : smooth(s);
            
    b0 = 0.000257077328090757*Gain*fs - 0.000257077328090757*fs;
    b1 = -0.000257077328090757*Gain*fs + 0.000257077328090757*fs;
    a0 = 2.08237464507809e-5*fs + 0.000460170362516827;
    a1 = -2.08237464507809e-5*fs + 0.000460170362516827;
};

smooth(s) = *(1.0 - s) : + ~ *(s);

iir(bv,av) = sub ~ fir(av) : fir(bv);

fir((b0,bv)) = _ <: *(b0), R(1,bv) :> _ with {
	R(n,(bn,bv)) = (@(n):*(bn)), R(n+1,bv);
	R(n, bn) = (@(n):*(bn));
};
fir(b0) = *(b0);

sub(x,y) = y-x;

lowpass(N,fc) = lowpass0_highpass1(0,N,fc);

lowpass0_highpass1(s,N,fc) = lphpr(s,N,N,fc)
with {
  lphpr(s,0,N,fc) = _;
  lphpr(s,1,N,fc) = tf1s(s,1-s,1,2*PI*fc);
  lphpr(s,O,N,fc) = lphpr(s,(O-2),N,fc) : tf2s(s,0,1-s,a1s,1,w1) with {
    parity = N % 2;
    S = (O-parity)/2; // current section number
    a1s = -2*cos((PI)*-1 + (1-parity)*PI/(2*N) + (S-1+parity)*PI/N);
    w1 = 2*PI*fc;
  };
};

tf1(b0,b1,a1) = _ <: *(b0), (mem : *(b1)) :> + ~ *(0-a1);

tf1s(b1,b0,a0,w1) = tf1(b0d,b1d,a1d)
with {
  c   = 1/tan(w1*0.5/SR); // bilinear-transform scale-factor
  d   = a0 + c;
  b1d = (b0 - b1*c) / d;
  b0d = (b0 + b1*c) / d;
  a1d = (a0 - c) / d;
};

tf2(b0,b1,b2,a1,a2) = iir((b0,b1,b2),(a1,a2));

tf2s(b2,b1,b0,a1,a0,w1) = tf2(b0d,b1d,b2d,a1d,a2d)
with {
  c   = 1/tan(w1*0.5/SR); // bilinear-transform scale-factor
  csq = c*c;
  d   = a0 + a1 * c + csq;
  b0d = (b0 + b1 * c + b2 * csq)/d;
  b1d = 2 * (b0 - b2 * csq)/d;
  b2d = (b0 - b1 * c + b2 * csq)/d;
  a1d = 2 * (a0 - csq)/d;
  a2d = (a0 - a1*c + csq)/d;
};

highpass(N,fc) = lowpass0_highpass1(1,N,fc);

BP(block) = bypass(checkbox("ON"), block);

peak_eq_cq(Lfx,fx,Q) = peak_eq(Lfx,fx,fx/Q);

peak_eq(Lfx,fx,B) = tf2s(1,b1s,1,a1s,1,wx) with {
  T = float(1.0/SR);
  Bw = B*T/sin(wx*T); // prewarp s-bandwidth for more accuracy in z-plane
  a1 = PI*Bw;
  b1 = g*a1;
  g = db2linear(abs(Lfx));
  b1s = select2(Lfx>0,a1,b1); // When Lfx>0, pole dominates bandwidth
  a1s = select2(Lfx>0,b1,a1); // When Lfx<0, zero dominates
  wx = 2*PI*fx;
};

db2linear(l) = pow(10, l/20.0);

delay(n,d,x) = x @ min(n, max(0,d));

interpolate(i) = *(1.0-i),*(i) : +;

sdelay(N, it, dt) = ctrl(it,dt),_ : ddi(N)
with {
	// ddi(N,i,d0,d1)
	// DDI (Double Delay with Interpolation) : the input signal is sent to two
	// delay lines. The outputs of these delay lines are crossfaded with
	// an interpolation stage. By acting on this interpolation value one
	// can move smoothly from one delay to another. When <i> is 0 we can
	// freely change the delay time <d1> of line 1, when it is 1 we can freely change
	// the delay time <d0> of line 0.
	//
	// <N>  = maximal delay in samples
	// <i>  = interpolation value between 0 and 1 used to crossfade the outputs of the
	// 		two delay lines (0.0: first delay line, 1.0: second delay line)
	// <d0> = delay time of delay line 0 in samples between 0 and <N>-1
	// <d1> = delay time of delay line 1 in samples between 0 and <N>-1
	// <  > = the input signal we want to delay
	ddi(N, i, d0, d1) = _ <: delay(N,d0), delay(N,d1) : interpolate(i);

	// ctrl(it,dt)
	// Control logic for a Double Delay with Interpolation according to two
	//
	// USAGE : ctrl(it,dt)
	// where :
	// <it> an interpolation time (in samples, for example 256)
	// <dt> a delay time (in samples)
	//
	// ctrl produces 3 outputs : an interpolation value <i> and two delay
	// times <d0> and <d1>. These signals are used to control a ddi (Double Delay with Interpolation).
	// The principle is to detect changes in the input delay time dt, then to
	// change the delay time of the delay line currently unused and then by a
	// smooth crossfade to remove the first delay line and activate the second one.
	//
	// The control logic has an internal state controlled by 4 elements
	// <v> : the interpolation variation (0, 1/it, -1/it)
	// <i> : the interpolation value (between 0 and 1)
	// <d0>: the delay time of line 0
	// <d1>: the delay time of line 1
	//
	// Please note that the last stage (!,_,_,_) cut <v> because it is only
	// used internally.
	ctrl(it, dt) = \(v,ip,d0,d1).((nv, nip, nd0, nd1)
	with {
		// interpolation variation
		nv = if (v!=0.0,                         // if variation we are interpolating
			if ((ip>0.0) & (ip<1.0), v, 0),      // should we continue or not ?
			if ((ip==0.0) & (dt!=d0), 1.0/it,    // if true xfade from dl0 to dl1
			if ((ip==1.0) & (dt!=d1), -1.0/it,   // if true xfade from dl1 to dl0
					 0)));                  // nothing to change
		// interpolation value
		nip = ip+nv : min(1.0) : max(0.0);

		// update delay time of line 0 if needed
		nd0 = if ((ip >= 1.0) & (d1!=dt), dt, d0);

		// update delay time of line 0 if needed
		nd1 = if ((ip <= 0.0) & (d0!=dt), dt, d1);
	} ) ~ (_,_,_,_) : (!,_,_,_);
};

process = input12au7:*(0.1):BP(iec_in:machine:iec_out):output12au7:lowpass(2, 20000);